<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Modelo de Franquicia</strong>
    </div>
    <!-- <div class="cotm">
      <div class="tmod">
        <strong>Consulta la información de tus sucursales</strong>
      </div>
    </div>-->
    <!-- Contenido -->
    <div class="contSecc">
      <div class="titSecCard">Búsqueda</div>
      <v-card style="background-color: #fafafa;">
        <v-container fluid>
          <div class="indicaciones">
            Consulta la información de tus sucursales, completa los campos por
            los que deseas buscar.
          </div>
          

          <v-row align="center">
            <!-- Negocio -->
            <v-col cols="4">
              <div class="titCampos">Negocio</div>
              <v-select
                ref="negocio"
                v-model="selectedNegocio"
                item-text="negocio"
                item-value="id"
                :items="negocios"
                placeholder="Selecciona el negocio a consultar"
                dense
                outlined
                return-object
                :rules="[() => !!selectedNegocio || 'Debes seleccionar el negocio']"
              ></v-select>

            </v-col>
            <!-- FECHA INICIO -->
            <v-col cols="4">
              <div class="titCampos">Fecha Inicio</div>
              <v-flex>
                <v-menu
                  ref="menuInicio"
                  v-model="menuInicio"
                  :close-on-content-click="false"
                  :nudge-right="40"
                  :return-value.sync="fechaInicio"
                  transition="scale-transition"
                  offset-y
                  min-width="290px"
                >
                  <template v-slot:activator="{ on }">
                    <v-text-field
                      ref="fechaInicioTF"
                      outlined
                      dense
                      v-model="fechaInicio"
                      placeholder="Selecciona una fecha inicio"
                      prepend-icon
                      readonly
                     
                      v-on="on"
                      :rules="[() => !!fechaInicio || 'Debes seleccionar la fecha Inicio']"
                      prepend-inner-icon="mdi-calendar-month"
                    ></v-text-field>
                  </template>

                  <v-date-picker
                    v-model="fechaInicio"
                    no-title
                    scrollable
                    color="#ffcd00"
                  >
                    <v-spacer></v-spacer>
                    <v-btn
                      text
                      color="primary"
                      @click="$refs.menuInicio.save(fechaInicio)"
                      >Seleccionar</v-btn
                    >
                    <v-btn text color="primary" @click="menuInicio = false"
                      >Cancelar</v-btn
                    >
                    <v-btn
                      text
                      color="primary"
                      @click="$refs.menuInicio.save(null)"
                      >Limpiar</v-btn
                    >
                  </v-date-picker>
                </v-menu>
              </v-flex>
            </v-col>
            <!-- FECHA FIN -->
            <v-col cols="4">
              <div class="titCampos">Fecha Fin</div>
              <v-flex>
                <v-menu
                  ref="menuFin"
                  v-model="menuFin"
                  :close-on-content-click="false"
                  :nudge-right="40"
                  :return-value.sync="fechaFin"
                  transition="scale-transition"
                  offset-y
                  min-width="290px"
                >
                  <template v-slot:activator="{ on }">
                    <v-text-field
                      ref="fechFinTF"
                      outlined
                      dense
                      v-model="fechaFin"
                      placeholder="Selecciona una fecha fin"
                      prepend-icon
                      readonly
                      v-on="on"
                      :rules="[() => !!fechaFin || 'Debes seleccionar la fecha fin']"
                      prepend-inner-icon="mdi-calendar-month"
                    ></v-text-field>
                  </template>

                  <v-date-picker
                    v-model="fechaFin"
                    no-title
                    scrollable
                    color="#ffcd00"
                  >
                    <v-spacer></v-spacer>
                    <v-btn
                      text
                      color="primary"
                      @click="
                        $refs.menuFin.save(fechaFin);
                        validaFecha();
                      "
                      >Seleccionar</v-btn
                    >
                    <v-btn text color="primary" @click="menuFin = false"
                      >Cancelar</v-btn
                    >
                    <v-btn
                      text
                      color="primary"
                      @click="$refs.menuFin.save(null)"
                      >Limpiar</v-btn
                    >
                  </v-date-picker>
                </v-menu>
              </v-flex>
            </v-col>
          </v-row>
          <br />
          <v-row align="center">
            <!-- BUSCAR -->
            <v-col cols="4"></v-col>
            <v-col cols="4">
              <v-btn block color="primary" @click="goToResumenNegocio" dark>
                <strong style="font-size: 16px; color: #000;">Buscar</strong>
              </v-btn>
            </v-col>
            <v-col cols="4"></v-col>
          </v-row>
        </v-container>
      </v-card>
    </div>
    <!-- Fin conSecc -->
  </div>
</template>
<style scoped></style>
<script>
import router from "@/router";
import store from "@/store";
const axiosChecklist = store.state.axiosChecklist;
import axios from "axios";
const serviceCommons = store.state.serviceCommons;
export default {
  data() {
    return {
      negocios : [
        { negocio:'ELEKTRA',
          id : 21
        },
        { negocio:'DAZ',
          id : 25
        },
        { negocio:'OCC',
          id : 28
        }],
      selectedNegocio : "",

      menuInicio: false,
      menuFin: false,
      
      fechaInicio: "",
      fechaFin: "",
      
      
      
      metadata: {
        tiposRecorrido: [],
        cecos: [],
      },
      search: "",
      
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Modelo de entrega ",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_entrega",
          },
        },
        {
          text: "Busqueda por negocio",
          disabled: true,
          exact: true
        },
      ],
    };
  },
  methods: {
    validaFecha() {

      if (this.fechaInicio != null) {
        var fi = new Date();
        var ff = new Date();

        var fechaInicial = this.fechaInicio.split("-");
        var fechaFinal = this.fechaFin.split("-");

        fi.setFullYear(fechaInicial[2], fechaInicial[1], fechaInicial[0]);
        ff.setFullYear(fechaFinal[2], fechaFinal[1], fechaFinal[0]);

        if (ff >= fi) {
          return true;
        } else {
          //alert("LA FECHA FIN DEBE SER MAYOR A LA INICIAL");
          this.fechaFin = null;
          this.$refs.menuFin.save(null);
          return false;
        }
      } else {
        //alert("SIN FECHA INICIAL");
        this.fechaFin = null;
        this.$refs.menuFin.save(null);
      }
    },
    goToResumenNegocio(){

      var fi = true;
      var ff = true;
      var ne = true;

      if(!this.fechaInicio){
        this.$refs.fechFinTF.validate(true); 
        fi = false; 
      }

      if(!this.fechaFin){
        this.$refs.fechaInicioTF.validate(true);
        ff=false;
      }

      if(!this.selectedNegocio){
        this.$refs.negocio.validate(true);
        ne = false;
      }


      if(fi && ff && ne){

        var dataObject = {
            selectedNegocio : this.selectedNegocio,
            fechaInicio: this.fechaInicio.replace("-","").replace("-",""),
            fechaFin :this.fechaFin.replace("-","").replace("-","")
          };

        router.push({
            name : "modelo_franquicia_totales_hallazgos_negocio",
            params : {
              datosBusqueda : serviceCommons.objectToBase64(dataObject)
            }
        });
      }

        
    }
  },

  created() {},
};
</script>
